#include <stdio.h>   /* Standard input/output definitions */
#include <string.h>  /* String function definitions */
#include <unistd.h>  /* UNIX standard function definitions */
#include <fcntl.h>   /* File control definitions */
#include <termios.h> /* POSIX terminal control definitions */
#include <stdlib.h>
#include <netdb.h>
#include "udp.h"
#define EXACTBYTES 10

struct termios saveterm;

// Serial port initialisation

int init_serial(char *device){
        struct termios new;
        int fd=open(device,O_RDWR|O_NOCTTY);
        if(fd<0){perror(device); exit(-1);}
        tcgetattr(fd,&saveterm); /* save current port settings */
        bzero(&new,sizeof(new));
        new.c_cflag=CLOCAL|CREAD|CS8;
        new.c_iflag=0;
        new.c_oflag=0;
        new.c_lflag=0;  /* set input mode (non-canonical, no echo,...) */
        new.c_cc[VTIME]=0; /* inter-character timer unused */
        new.c_cc[VMIN]=EXACTBYTES; /* blocking read until 1 char received */
        cfsetospeed(&new, B115200);
        cfsetispeed(&new, B115200);

        tcflush(fd, TCIFLUSH);
        tcsetattr(fd,TCSANOW,&new);
        return fd;
}

// Close serial port

void close_serial(int fd){
        tcsetattr(fd,TCSANOW,&saveterm);
        close(fd);
}

void readBytes(int fd){
        char *hote="193.48.57.161";
        //char *message;
        char *service="4848";
        unsigned char data[EXACTBYTES], tmp='0';
        while(tmp!='/'){
                read(fd,&tmp, 1);
        }
        while(1){
                read(fd, data, EXACTBYTES);
                //write(STDOUT_FILENO, data, EXACTBYTES);
                UDPmessage(hote,service,data,EXACTBYTES);
        }
}
