#!/bin/bash


ipPrefix="172.20.11."



if [ $# -eq 2 ]; then
ip=$ipPrefix$1

ping -c5 $ip &> /dev/null ; pong=$?
if [[ $pong == 1 ]]; then
	#mkdir -pm 775 /var/www/troisiemesexe.lol/log
	echo -n "["`date +'%d/%m/%Y-%H:%M:%S'`"] : Reset initiated for daughter board $2..." >> /var/www/troisiemesexe.lol/log/files/board$1.log
	echo "Raspberry not reachable or not connected" >> /var/www/troisiemesexe.lol/log/files/board$1.log
	exit	
fi

case "$2" in
[aA])   file="carte_a.hex"
        ;;
[bB])   file="carte_b.hex"
        ;;
[cC])   file="carte_c.hex"
        ;;
[dD])   file="carte_d.hex"
        ;;
[eE])   file="carte_e.hex"
        ;;
[fF])   file="carte_f.hex"
        ;;
[gG])   file="carte_g.hex"
        ;;
[hH])   file="carte_h.hex"
        ;;
esac

if [ -f "/var/www/backup/$file" ]; then
	sshpass -p raspberry /usr/bin/scp /var/www/backup/$file pi@$ip:/home/pi/autoconf
else
	echo $2 'file not found'
	exit
fi

if [[ $2 == [a-hA-H] ]]; then  
#mkdir -pm 775 /var/www/troisiemesexe.lol/log
echo -n "["`date +'%d/%m/%Y-%H:%M:%S'`"] : Reset done for daughter board $2..." >> /var/www/troisiemesexe.lol/log/files/board$1.log
sshpass -p raspberry /usr/bin/ssh -p22 pi@$ip "/usr/bin/sudo bash -c 'source $HOME/.bashrc; cd /home/pi/autoconf; multipdi.sh $2 $file'" 2>&1 | tr -d '\n' >> /var/www/troisiemesexe.lol/log/files/board$1.log
echo >> /var/www/troisiemesexe.lol/log/files/board$1.log
else
	echo $2 'type of board not known'
	exit
fi


else
	echo Give 2 parameters which should be a boardId subboardId
fi
