<?php defined('BASEPATH') OR exit('No direct script access allowed');

class Admin extends CI_Controller{
	
	function __construct(){
	
		parent:: __construct();	
		date_default_timezone_set($this->event_calendar->get_timeZone());
		$this->session->set_userdata('default_lang', $this->event_calendar->get_settings_data()->row()->default_language);
		$this->load->model('event_calendar_model');
	}

/*
===================================================================================================================
|																												  |
|											   index													          |												  |
|																												  |
===================================================================================================================
*/	
	
	public function index(){
		
			$protocol = (@$_SERVER["HTTPS"] == "on") ? "https://" : "http://";
			if (substr($_SERVER['HTTP_HOST'], 0, 4) !== 'www.') {
				header('Location: '.$protocol.'www.'.$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI']);
				exit;
			}
		
			if($this->event_calendar->check_authentication()){
				$this->session->sess_destroy();
				$title['title'] = "Login";
				$this->load->view('admin/admin-login');
			}else{
				redirect(base_url('install'));	
			}			
				
	}
/*
===================================================================================================================
|																												  |
|											Dashboard													          |												  |
|																												  |
===================================================================================================================
*/	
	
	function dashboard($type = "all-events"){
		
		if($this->event_calendar->check_authentication()){			
			if($this->event_calendar->check_admin()){
				$this->load->library('pagination');
				$config = $this->event_calendar->get_pagination_link("admin/dashboard/$type/", $type);
				$this->pagination->initialize($config);		
				$data['events'] = $this->event_calendar->get_pagination_data($type, $config['per_page'], $this->uri->segment(4)); 
				$data['settings'] = $this->event_calendar->get_settings_data();
				$data['def_vw'] =  ($this->session->userdata('def_vw')) ? $this->session->userdata('def_vw') : $data['settings']->row()->default_view;
				$data['title'] = 'Dashboard';	
				$data['type'] = ucwords(str_replace('-',' ',$type));	
				$data['enque_styles']  = $this->event_calendar->enque_styles('dashboard');	
				$data['enque_scripts']  = $this->event_calendar->enque_scripts('dashboard');
				$data['past_events'] = $this->event_calendar->get_past_events();	
				$data['upcoming_events'] = $this->event_calendar->get_upcoming_events();	
				$data['ongoing_events'] = $this->event_calendar->get_ongoing_events();		
				$this->load->view('admin/list-event', $data);
			}else{
				redirect(base_url('admin'));	
			}
		}else{
			redirect(base_url('install'));	
		}	
		
	}
	
/*
===================================================================================================================
|																												  |
|											Add Event												              |												  |
|																												  |
===================================================================================================================
*/	

	function add_event(){
		
		
		if($this->event_calendar->check_authentication()){			
			if($this->event_calendar->check_admin()){
				$data['title'] = 'Add Event';	
				$data['settings'] = $this->event_calendar->get_settings_data();	
				$data['enque_styles'] = $this->event_calendar->enque_styles('add-event');	
				$data['enque_scripts'] = $this->event_calendar->enque_scripts('add-event');		
				$this->load->view('admin/add-event',$data);
			}else{
				redirect(base_url('admin'));	
			}
		}else{
			redirect(base_url('install'));	
		}
		
	}
	
/*
===================================================================================================================
|																												  |
|											Edit Event													          |												  |
|																												  |
===================================================================================================================
*/	
	
	
	function edit_event($event_id=FALSE){
		
		if($this->event_calendar->check_authentication()){			
			if($this->event_calendar->check_admin()){
				if(!$event_id == FALSE)	{			
					$data['event'] =  $this->event_calendar->get_event_by_id($event_id);
					$data['location'] = $this->event_calendar->get_locationt_by_id($event_id);
					$data['images']  = $this->event_calendar->get_image_by_id($event_id);
					$data['video']  = $this->event_calendar->get_video_by_id($event_id);
					$data['title'] = 'Edit Event';
					$data['settings'] = $this->event_calendar->get_settings_data();
					$data['enque_styles'] = $this->event_calendar->enque_styles('edit-event');	
					$data['enque_scripts'] = $this->event_calendar->enque_scripts('edit-event');	
					$this->load->view('admin/edit-event',$data);
				}else{
					redirect(base_url('admin/dashboard'));	
				}
			}else{
				redirect(base_url('admin'));	
			}
		}else{
			redirect(base_url('install'));	
		}
	}
	
/*
===================================================================================================================
|																												  |
|											View Event													          |												  |
|																												  |
===================================================================================================================
*/	
	function view_event($event_id = FALSE){
		
		if($this->event_calendar->check_authentication()){			
			if($this->event_calendar->check_admin()){
				if(!$event_id == FALSE)	{		
					$data['events'] =  $this->event_calendar->get_event_by_id($event_id);
					$data['locations']  = $this->event_calendar->get_locationt_by_id($event_id);
					$data['images']  = $this->event_calendar->get_image_by_id($event_id);
					$data['videos']   = $this->event_calendar->get_video_by_id($event_id);
					$data['title'] = $this->event_calendar->get_event_title($event_id);
					$data['settings']  = $this->event_calendar->get_settings_data();
					$data['enque_scripts']  = $this->event_calendar->enque_scripts('view-event');
					$this->load->view('admin/single-event',$data);
				}else{
					redirect(base_url('admin/dashboard'));	
				}
			}else{
				redirect(base_url('admin'));	
			}
		}else{
			redirect(base_url('install'));	
		}
		
	}
	
	
/*
===================================================================================================================
|																												  |
|											Login 														          |												  |
|																												  |
===================================================================================================================
*/	
	
	
	public function login(){		
		
		if($this->event_calendar->check_authentication()){
				$loginData = $this->form_data->get_data_login_form();
				$this->load->library('encryption');
				$loginData['user_password'] = $this->encryption->encrypt($loginData['user_password']);
				$result = $this->event_calendar_model->login($loginData);
				if($result){
					$this->session->set_userdata('admin', 'true');
					$this->session->set_userdata('username',$loginData['user_name'] );
					$event_type = $this->event_calendar->get_settings_data()->row()->event_type;
					redirect(base_url("admin/dashboard/$event_type"));
				}else{
					$this->session->set_flashdata('logged', 'failed');
					redirect(base_url('admin'));
				}
		}else{
			redirect(base_url('install'));	
		}			
		
	}
	
	
/*
===================================================================================================================
|																												  |
|											Logout 														          |												  |
|																												  |
===================================================================================================================
*/	
	
	
	public function logout(){
		
		redirect(base_url('admin'));
	}

/*
===================================================================================================================
|																												  |
|											mail 													  |												  |
|																												  |
===================================================================================================================
*/	
	
	
	function mail_via(){
					
		$config = array(
			  'protocol' => 'mail',
			  'mailpath' => '/usr/sbin/sendmail',
			  'charset' => 'utf-8',
			  'mailtype' => 'html',
			  'crlf' => '\r\n',
			  'newline' => '\r\n',
			  'wordwrap' => TRUE
		);
		return $config;			
	}
	
	function sendMail($from, $to, $subject, $message = "" ){		
		
		$from_name = $this->event_calendar->from_name();
		$this->load->library('email');			
		$this->email->initialize($this->mail_via());						
		$this->email->from($from, $from_name);
		$this->email->to($to);
		$this->email->subject($subject);
		$this->email->message($message);
		if($this->email->send()){
			return 1;
		}
		return 0;
		
	}
	
	
/*
===================================================================================================================
|																												  |
|											forgot Passwprd 													  |												  |
|																												  |
===================================================================================================================
*/	
	
	public function forgot_password(){
		
		if($this->event_calendar->check_authentication()){					
				$data['title'] = "Forgot Password";
				$this->load->view('admin/forgot-password', $data);			
		}else{
			redirect(base_url('install'));	
		}
	}

	function send_password(){
		
		if($this->event_calendar->check_authentication()){					
			$username = 'User';
			$forgotData = $this->form_data->get_data_forgot_form();
			$passData = $this->get_pass_data($forgotData['user_email']);
			if(!empty($passData['name'])){
				$username = $passData['name'];
			}	
			if($passData > 0){
				$data['name'] = $username;
				$data['password'] = $passData['pass'];
				$data['site_name'] = $this->event_calendar->get_site_name();

				$message = $this->load->view('admin/forgot-password-tpl', $data, TRUE);
				$from_email = $this->event_calendar->mail_from() ;				
				$from = ($from_email) ? $from_email : $passData['email'];
				$to = $forgotData['user_email'];
				$subject = "Forgot Password";
				if($this->sendMail($from, $to, $subject, $message)){
					$this->session->set_flashdata('email','send-success');
					redirect(base_url('admin/forgot-password'));
				}else{
					$this->session->set_flashdata('email','send-failed');
					redirect(base_url('admin/forgot-password'));
				}	
			}else{
				$this->session->set_flashdata('email','not-found');
				redirect(base_url('admin/forgot-password'));
			}
		}else{
			reditect('install');	
		}
	}
		
/*
===================================================================================================================
|																												  |
|											Change Password														  |												  |
|																												  |
===================================================================================================================
*/	
	
	
	public function change_password(){
		
		if($this->event_calendar->check_authentication()){
			if($this->event_calendar->check_admin()){
				$data['settings'] = $this->event_calendar->get_settings_data();				
				$this->load->view('admin/change-password',$data);				
			}else{
				redirect(base_url('admin'));	
			}
		}else{
			redirect(base_url('install'));	
		}
		
	}
	
	function updatePassword(){
		
		if($this->event_calendar->check_authentication()){
			if($this->event_calendar->check_admin()){
	
				$changePasswordData = $this->form_data->get_data_changePassword_form();
				if($changePasswordData['NewPassword'] == $changePasswordData['RepeatPassword']){
					$this->load->library('encryption');
					$changePasswordData['OldPassword'] = $this->encryption->encrypt($changePasswordData['OldPassword']);
					$changePasswordData['NewPassword'] = $this->encryption->encrypt($changePasswordData['NewPassword']);
					$result = $this->event_calendar_model->changePassword($changePasswordData);
					if($result){
						$this->session->set_flashdata('logged', 'success');
						redirect(base_url('admin/change-password'));
					}else{
						$this->session->set_flashdata('logged', 'failed');
						redirect(base_url('admin/change-password'));
					}
				}else{
					
					$this->session->set_flashdata('logged', 'notmatch');
					redirect(base_url('admin/change-password'));
					
				}
			}else{
				redirect(base_url('admin'));	
			}
		}else{
			redirect(base_url('install'));	
		}
			
	}
	
/*
===================================================================================================================
|																												  |
|											Settings													          |												  |
|																												  |
===================================================================================================================
*/	
	
	
	public function settings(){
		
		if($this->event_calendar->check_authentication()){
			if($this->event_calendar->check_admin()){
				$data['settings'] = $this->event_calendar->get_settings_data();
				$data['enque_styles'] = $this->event_calendar->enque_styles('settings');
				$data['enque_scripts'] = $this->event_calendar->enque_scripts('settings');
				$data['title'] = 'settings';
				$data['admin_email'] = $this->get_admin_email();
				$data['languages'] = $this->event_calendar->get_all_languages();
				$this->session->set_userdata('default_lang', $data['settings']->row()->default_language );
				$this->load->view('admin/settings', $data);				
			}else{
				redirect(base_url('admin'));	
			}
		}else{
			redirect(base_url('install'));	
		}
	}
	
	private function get_pass_data($email){
		
		$result = $this->event_calendar_model->get_pass_data($email);		
		return $result;
		
	}
	
	
/*
===================================================================================================================
|																												  |
|											      UPDATE FUNCTION											      |												  |
|																												  |
===================================================================================================================
*/
	
	
	function updateEvent($event_id=FALSE){
		
		if($this->event_calendar->check_authentication()){			
			if($this->event_calendar->check_admin()){
				if(!$event_id == FALSE)	{		
				
					$addEventData = $this->form_data->get_data_event_form_add();
					$addEventData['event_url'] = base_url("event/model/$event_id");
				    $addEventData['event_view_url']  = base_url("event/".$this->event_calendar->get_url_tilte($addEventData['event_title']));
					$addLocationData = $this->form_data->get_data_event_form_location();		
					
					$result1 = $this->event_calendar_model->updateEvent($event_id,$addEventData);
					$result2 = $this->event_calendar_model->updateLocation($event_id,$addLocationData);
					
					$imageData = $this->form_data->get_data_event_form_image();
					if(!empty($imageData)){
						$this->event_calendar_model->updateImage($event_id,$imageData);
					}else{
						$this->event_calendar_model->deleteAllImages();
					}
					$videoData = $this->form_data->get_data_event_form_video();
					if(!empty($videoData)){
						$this->event_calendar_model->updateVideo($event_id,$videoData);
					}
					
					if(( $result1 > 0 ) && ( $result2 > 0 )){ 
						$this->session->set_flashdata('event', 'update_success'); 
						redirect('admin/edit-event/'.$event_id); 
					}else{ 
					
						$this->session->set_flashdata('event', 'update_failed'); 
						redirect('admin/edit-event/'.$event_id);
					}
				}else{
					redirect('admin/dashboard');	
				}
			}else{
				redirect('admin');	
			}
		}else{
			redirect('install');	
		}
	}
	
	function updateSettings(){		
		
		if($this->event_calendar->check_authentication()){			
			if($this->event_calendar->check_admin()){

				$settingsData = $this->form_data->get_data_event_form_settings();
				$result = $this->event_calendar_model->updateSettings($settingsData);
				if( $result > 0 ){ 
					$this->session->set_flashdata('settings', 'update_success'); 
					redirect('admin/settings/'); 
				}else{ 
				
					$this->session->set_flashdata('settings', 'update_failed'); 
					redirect('admin/settings/');
				}
			}else{
				redirect('admin');	
			}
		}else{
			redirect('install');	
		}
			

		
	}
	

	
/*
===================================================================================================================
|																												  |
|											       INSERT FUNCTION											      |												  |
|																												  |
===================================================================================================================
*/
	
	
	function insertEvent(){
		
		if($this->event_calendar->check_authentication()){			
			if($this->event_calendar->check_admin()){
				
				$addEventData = $this->form_data->get_data_event_form_add();	
				$addEventData['event_url'] = base_url("event/model/".$this->event_calendar->get_next_event_id());
				$addEventData['event_view_url']  = base_url("event/".$this->event_calendar->get_url_tilte($addEventData['event_title']));
				
				$resultAdd = $this->event_calendar_model->saveEvent($addEventData);
				
				$addLocationData = $this->form_data->get_data_event_form_location();
				$addLocationData['event_id'] = $this->event_calendar->get_event_id();		
				$resultLocation = $this->event_calendar_model->saveLocation($addLocationData);
				
				$imageData = $this->form_data->get_data_event_form_image();
				if(!empty($imageData)){
					$imageData['event_id'] = $this->event_calendar->get_event_id();		
					$this->event_calendar_model->saveImage($imageData);
					
				}
				$videoData =$this->form_data->get_data_event_form_video();
				if(!empty($videoData)){
					$videoData['event_id'] = $this->event_calendar->get_event_id();
					$this->event_calendar_model->saveVideo($videoData);
				}
				
				//Modifications
				$boardData = $this->form_data->get_data_event_form_boards();
				$boardData['roleName'] = "admin";
				if(!empty($imageData)){
					$fileName				= $imageData['image_name'];
					$boardData['fileName'] 	= $fileName[0];
				}
				$this->event_calendar_model->saveRpiConf($boardData, $this->event_calendar->get_event_id());
				//end of modifications
				if(( $resultAdd > 0 ) && ( $resultLocation > 0 )){ 
					$this->session->set_flashdata('event', 'add_success'); 
					redirect('admin/edit-event/'.$this->event_calendar->get_event_id());
				}
				else{ 		
					$this->session->set_flashdata('event', 'add_failed'); 
					redirect('admin/add-event');
				}	
			}else{
				redirect('admin');	
			}
		}else{
			redirect('install');	
		}
	}
	
	private function get_admin_email(){
		
		$this->db->select('user_email');
		$result = $this->db->get('event_calendar_login');
		$result = $result->row();
		return $result->user_email;
			
	}
	

	
}

/*
*End of Admin.php
*Source: ../application/modules/admin/controller/Admin.php
*/