<?php defined('BASEPATH') OR die('No direct script access allowed');

class Install extends CI_Controller{ 	

	
	function index(){
		
		$protocol = (@$_SERVER["HTTPS"] == "on") ? "https://" : "http://";
		if (substr($_SERVER['HTTP_HOST'], 0, 4) !== 'www.') {
			header('Location: '.$protocol.'www.'.$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI']);
			exit;
		}
		if($this->event_calendar->check_authentication()){			
			$this->load->view('install/install-already');			
		}else{			
			$this->load->view('install/install-page');
		}
			
	}
	
	function step_1(){	
		
		if($this->input->post('submit') == 'Install'){
			
			$databaseData = $this->form_data->get_data_install_form_database_info();
			$adminData = $this->form_data->get_data_install_form_admin();	
			
			$info = $this->configuration_connection();
			
			if($info == "connection-success" ){
				
				$info = $this->configuration_database();
				
				if($info == "database-success"){
					
					if($this->configuration_table()){
						$this->update_data();
						$this->event_calendar->evc_config_file();
						redirect('install/step-2');
					}
					
				}else{
					$this->session->set_flashdata('database-info', 'failed');
					$data['inputs_database'] = $databaseData;
					$data['inputs_admin'] = $adminData;
					$this->load->view('install/install-page',$data);
				}
				
			}else{
				
				$this->session->set_flashdata('connection-info', 'failed');
				$data['inputs_database'] = $databaseData;
				$data['inputs_admin'] = $adminData;
				$this->load->view('install/install-page',$data);				
			}
			
		}else{ 
			redirect('install'); 
		}	
		
		
	}
	
	function step_2(){
		
		$this->load->view('install/install-success');
		
	}
	
	function configuration_connection(){
		
		$databaseData = $this->form_data->get_data_install_form_database_info();
		$adminData = $this->form_data->get_data_install_form_admin();	
		
		$conn = @mysqli_connect($databaseData['hostname'], $databaseData['username'], $databaseData['password']);
		
		if(mysqli_connect_errno()){
			
			return "connection-failed";
		}
		return "connection-success";

	}
	
	function configuration_database(){
		
		$databaseData = $this->form_data->get_data_install_form_database_info();		
		$adminData = $this->form_data->get_data_install_form_admin();		
		
		$outpath = $this->event_calendar->evc_config_db_connection($databaseData['hostname'], $databaseData['username'], $databaseData['password']);
		
		if($outpath)
		{				
			$this->load->dbutil();
			if(! $this->dbutil->database_exists($databaseData['database']))
			{							
				$this->db->close();
				return "database-failed";
			}else{
				$this->db->close();
				return "database-success";
			}			
			
		}else{
			redirect('install');
		}
			
	}
	
	function configuration_table(){
		
		$databaseData = $this->form_data->get_data_install_form_database_info();		
		$adminData = $this->form_data->get_data_install_form_admin();		
		
		$outpath = $this->event_calendar->evc_config_db_database($databaseData['hostname'], $databaseData['username'], $databaseData['password'], $databaseData['database']);
		
		if($outpath)
		{
			$install = $this->upload_table_to_database();			
			if($install){
				return 1;				
			}
		}
		redirect('install');
	}
	
	function update_data(){
	
		$loginData = $this->form_data->get_data_install_form_admin();
		$login = $this->update_admin($loginData);
		if($login){
			$this->insert_setting();
		}
		
	}

	
	function upload_table_to_database(){
	
			$login = $this->event_calendar_login();
			$event = $this->event_calendar_event();
			$location = $this->event_calendar_location();
			$image = $this->event_calendar_image();
			$video = $this->event_calendar_video();
			$setting = $this->event_calendar_setting();
			
			if($login && $event && $location && $image && $video &&  $setting)
				return 1;
				
			return 0;
	
	}
	
	function event_calendar_login(){
		
		$this->load->model('event_calendar_model');
		$result = $this->event_calendar_model->event_calendar_login();
		return $result;	
	}
	
	function event_calendar_event(){
		
		$this->load->model('event_calendar_model');
		$result = $this->event_calendar_model->event_calendar_event();
		return $result;	
	}
	
	function event_calendar_location(){
		
		$this->load->model('event_calendar_model');
		$result = $this->event_calendar_model->event_calendar_location();
		return $result;	
	}
	
	function event_calendar_image(){
		
		$this->load->model('event_calendar_model');
		$result = $this->event_calendar_model->event_calendar_image();
		return $result;	
	}
	
	function event_calendar_video(){
		
		$this->load->model('event_calendar_model');
		$result = $this->event_calendar_model->event_calendar_video();
		return $result;	
	}
	
	function event_calendar_setting(){
	
		$this->load->model('event_calendar_model');
		$result = $this->event_calendar_model->event_calendar_setting();
		return $result;	
	}
	
	function update_admin($adminData){
		
		$this->load->model('event_calendar_model');
		$this->load->library('encryption');
		$adminData['user_password'] = $this->encryption->encrypt($adminData['user_password']);
		
		$result = $this->event_calendar_model->get_login();
		if($result->num_rows() > 0)			
			$result = $this->event_calendar_model->update_login($adminData);
		else
			$result = $this->event_calendar_model->insert_login($adminData);
		
		return $result;
	}
	
	function insert_setting(){
		$loginData = $this->form_data->get_data_install_form_admin();
		$admin_email = $loginData['user_email'];
		$this->load->model('event_calendar_model');
		$settingsData = array(
			'first_day'=> '2',
			'time_format'=> '2',
			'default_view'=>'list',
			'site_name' => 'Event Calendar',
			'event_type' => 'all-events',
			'default_calendar_view' => 'month',
			'default_timezone' => 'Asia/Kolkata',
            'default_language' => 'en-EN',
			'mail_from' => $admin_email,
			'from_name' => 'Eventro'
		);
		$result = $this->event_calendar_model->insert_setting($settingsData);
	}
	
	private function get_admin_email(){
		
		$this->db->select('user_email');
		$result = $this->db->get('event_calendar_login');
		$result = $result->row();
		return $result->user_email;
			
	}
	
}