<?php defined('BASEPATH') OR exit('No direct script access allowed');
 
 class Event_Calendar_Model extends CI_Model{
	 public $myDB;
	 function __construct(){
		 
		parent:: __construct(); 		
		$this->load->database('default');
		$this->myDB = $this->load->database('db2', TRUE);
	 }
	 
/*
===================================================================================================================
|																												  |
|											get function													      |												  |
|																												  |
===================================================================================================================
*/	
	 function get_table_login(){
		 
		 $table = "event_calendar_login";
		 return $table;
	 }
	 
	 function get_table_event(){
		 
		 $table = "event_calendar_event";
		 return $table;
	 }
	 
	 function get_table_location(){
		 
		 $table = "event_calendar_location";
		 return $table;
	 }
	 
	  function get_table_image(){
		  
		 $table = "event_calendar_image";
		 return $table;
	 }
	 
	 function get_table_video(){
		 
		 $table = "event_calendar_video";
		 return $table;
	 }
	 
	 function get_table_setting(){
		  
		 $table = "event_calendar_setting";
		 return $table;
	 }
	 
	 function getEventID(){	
		
		$table = $this->get_table_event();
		$this->db->select_max('event_id');
		$result = $this->db->get($table);
		$row = $result->row(); 
		return $row->event_id;
		
	}
	
	function get_all_events($type){
		
		$table = $this->get_table_event();
		$date = date('Y-m-d H:i:s');
		$result;	
		if($type == "all-events"){
			$result = $this->db->get($table);
		}elseif($type == "upcoming-events"){
			$this->db->where('end_date >=', $date);	
			$result =$this->db->get($table);
		}if($type == "past-events"){
			$this->db->where("end_date < ", $date);			
			$result =$this->db->get($table);
		}
		return $result;
		
	}
	
	function get_event_by_id($event_id){
		
		$table = $this->get_table_event();
		$this->db->where('event_id', $event_id);
		$result = $this->db->get($table);
		return $result;
	}
	
	function get_location_by_id($event_id){
		
		$table = $this->get_table_location();
		$this->db->where('event_id', $event_id);
		$result = $this->db->get($table);
		return $result;
	}
	
	function get_image_by_id($event_id){
		
		$table = $this->get_table_image();
		$this->db->where('event_id', $event_id);
		$result = $this->db->get($table);
		return $result;
	}
	
	function get_video_by_id($event_id){
		
		$table = $this->get_table_video();
		$this->db->where('event_id', $event_id);
		$result = $this->db->get($table);
		return $result;
	}
	
	function getLocations(){
		
		$table = $this->get_table_location();
		$result = $this->db->get($table);
		return $result;
	}
	
	function get_pass_data($email){

		$table = $this->get_table_login();
		$this->db->where('user_email',$email);
		$query = $this->db->get($table);
		if($query->num_rows() > 0 ){					
			$result = $query->row();		
			$this->load->library('encryption');			
			$passData = array(
			 		'pass' => $this->encryption->decrypt($result->user_password),
					 'name' => $result->nick_name,
					 'email' => $result->user_email
					);
			return $passData;
		}
		return 0;
		
	}
	
	function get_event_title($event_id){
		
		$table = $this->get_table_event();
		$this->db->select('event_title');
		$this->db->where('event_id', $event_id);
		$result = $this->db->get($table);
		if($result->num_rows() > 0 ){
			return $result->row()->event_title;
		}
		return "Eventro Eventcalendar";
	}
	
	function getAllEventsAjax($type){
		
		$table = $this->get_table_event();
		$result = $this->get_all_events($type);
		$data = array();
		if($result->num_rows() > 0){
			foreach($result->result() as $row){
				$data[] = array(
					'id' => $row->event_id,
					'title' => $row->event_title,
					'url' => $row->event_url,
					'start' => strtotime($row->start_date).'000',
					'end' =>strtotime($row->end_date).'000'				
				);			
			}
		}
		
		return $data;
		
	}
	
	function get_next_event_id(){
		
		$next = $this->db->query("SHOW TABLE STATUS LIKE 'event_calendar_event'");
		$next = $next->row(0);
        return $next->Auto_increment;
	
	}
	
	function get_settings_data(){
		
		$table = $this->get_table_setting();
		$result = $this->db->get($table);
		return $result;
		
	}
	
	function get_site_name(){
	
		$table = $this->get_table_setting();
		$this->db->select('site_name');
		$result = $this->db->get($table);
		if($result->num_rows() > 0){
			return $result->row()->site_name;
		}
		return "Eventro Eventcalendar";
	}
	
	function get_images(){
		
		$table = $this->get_table_image();
		$result = $this->db->get($table);
		return $result;
	}
	
	function get_event_meta_description($event_id){
		
		$table = $this->get_table_event();
		$this->db->select('event_description');
		$this->db->where('event_id', $event_id);
		$result = $this->db->get($table);
		if($result->num_rows() > 0){
		return $result->row()->event_description;
		}
		return "No-Description";
	}
	
	
	function getEvents(){
		
		$table = $this->get_table_event();
		$result = $this->db->get($table);
		return $result;
		
	}	
	
	function get_ongoing_events(){
		
		$date = date('Y-m-d H:i:s');
		$table = $this->get_table_event();
		$this->db->select('event_title');
		$this->db->where('start_date <=', $date);
		$this->db->where('end_date >=', $date);
		$result = $this->db->get($table);
		return $result;
		
	}
	
	function get_upcoming_events(){
		
		$date = date('Y-m-d H:i:s');
		$table = $this->get_table_event();
		$this->db->select('event_title');
		$this->db->where('start_date >', $date);
		$this->db->where('end_date >', $date);
		$result = $this->db->get($table);
		return $result;
		
	}
	
	function get_past_events(){
		
		$date = date('Y-m-d H:i:s');
		$table = $this->get_table_event();
		$this->db->select('event_title');
		$this->db->where('end_date < ', $date);
		$result = $this->db->get($table);
		return $result;
		
	}
	
	function delete_image_name($imageName){
				
		$table = $this->get_table_image();
		$result = $this->db->get($table);
		if($result->num_rows() > 0){
			
			$this->db->where('image_name', $imageName);
			$this->db->delete($table);
		}
		
	}
	 
	 function get_timezone(){
		$table = $this->get_table_setting();	
		$result = $this->db->get($table);
		$result = $result->row();
		return $result->default_timezone;
	 }
	 
	 public function get_event_type(){
		 
		$table = $this->get_table_setting();	
		$result = $this->db->get($table);
		$result = $result->row();
		return $result->event_type;
		 
	 }
	 
/*
===================================================================================================================
|																												  |
|											Mail 														          |												  |
|																												  |
===================================================================================================================
*/	
	 
	 function mail_protocol(){
		 
		 $table = $this->get_table_setting();
		 $result = $this->db->get($table);
		 $result = $result->row();
		 return $result->mail_protocol;
	 }
	 
	  function mail_from(){
		 
		 $table = $this->get_table_setting();
		 $result = $this->db->get($table);
		 $result = $result->row();
		 return $result->mail_from;
	 }
	 
	  function from_name(){
		 
		 $table = $this->get_table_setting();
		 $result = $this->db->get($table);
		 $result = $result->row();
		 return $result->from_name;
	 }
	 
	  function smtp_host(){
		 
		 $table = $this->get_table_setting();
		 $result = $this->db->get($table);
		 $result = $result->row();
		 return $result->smtp_host;
		 
	 }
	 
	  function smtp_username(){
		 
		 $table = $this->get_table_setting();
		 $result = $this->db->get($table);
		 $result = $result->row();
		 return $result->smtp_username;
		 
	 }
	 
	  function smtp_password(){
		 
		 $table = $this->get_table_setting();
		 $result = $this->db->get($table);
		 $result = $result->row();
		 return $result->smtp_password;
		 
	 }
	 
	  function smtp_port(){
		 
		 $table = $this->get_table_setting();
		 $result = $this->db->get($table);
		 $result = $result->row();
		 return $result->smtp_port;
		 
	 }
	 
	 
/*
===================================================================================================================
|																												  |
|											Login 														          |												  |
|																												  |
===================================================================================================================
*/	
	 
	 function login($loginData){		
		
		$table = $this->get_table_login();		
		$result = $this->db->get($table);
		
		if($result->num_rows() > 0 ){			
			$row = $result->row();
			$this->load->library('encryption');
			if($row->user_name == $loginData['user_name'] && $this->encryption->decrypt($row->user_password) == $this->encryption->decrypt($loginData['user_password'])){
				return 1;
			}
		}
		return 0;
	}
	
/*
===================================================================================================================
|																												  |
|											Save													              |												  |
|																												  |
===================================================================================================================
*/	
	/*my modif*/
	function saveRpiConf($RPIdata, $eventId){
		$file['fileName']			= $RPIdata['fileName'];
		$file['fileDescription']	= "Hex config file";
		$timeslot['startDate'] 		= $RPIdata['startDate'];
		$timeslot['startTime'] 		= $RPIdata['startTime'];
		$configuration 				= $timeslot;
		$configure 					= $timeslot;
		$timeslot['endTime'] 		= $RPIdata['endTime'];
		$this->myDB->insert('file', $file);
		$this->myDB->insert('timeslot', $timeslot);
		
		$configuration['userId'] 	= 1; //admin userID
		$configuration['fileName']	= $RPIdata['fileName'];
		$this->myDB->insert('configuration', $configuration);
		
		$configure['boardId'] 		= $RPIdata['boardAdd'];
		$configure['subId']			= $RPIdata['subboardAdd'];
		$configure['eventId']		= $eventId;
		$sql = "INSERT INTO board (id, subId) SELECT * FROM (SELECT '".$RPIdata['boardAdd']."', '".$RPIdata['subboardAdd']."') AS tmp WHERE NOT EXISTS ( SELECT id FROM board WHERE id = " .$RPIdata['boardAdd']. " AND subId='".$RPIdata['subboardAdd']."' ) LIMIT 1 ";
		$this->myDB->query($sql);
		
		
		$this->myDB->insert('configure', $configure);		
	}
	
	/*end of my modif*/
	function saveEvent($addEventData){
		
		$table = $this->get_table_event();
		$result = $this->db->insert($table, $addEventData);
		return $result;
	}
	
	function saveLocation($addLocationData){
		
		$table = $this->get_table_location();
		$result = $this->db->insert($table, $addLocationData);
		return $result;
	}
	
	function saveImage($imageData){
		
		$table = $this->get_table_image();
		$name  = $imageData['image_name'];
		$url   = $imageData['image_url'];
		$thubmUrl   = $imageData['image_thumb_url'];
		
		for($i=0; $i<count($name); $i++){
			$items = array(
				'image_name' => $name[$i],
				'image_url' => $url[$i],
				'image_thumb_url' => $thubmUrl[$i],
				'event_id' => $imageData['event_id']
				);
			$this->db->insert($table,$items);	
		}	
	}
	
	function saveVideo($videoData){
		
		$table = $this->get_table_video();
		$this->db->insert($table, $videoData);
	}
	
	
/*
===================================================================================================================
|																												  |
|											Change password											              |												  |
|																												  |
===================================================================================================================
*/	
	
	function changePassword($changePasswordData){
		
		$table = $this->get_table_login();
		$result = $this->db->get($table);		
		if($result->num_rows() > 0){
			$row = $result->row();
			$this->load->library('encryption');
			if( ($row->user_name == $this->session->userdata('username')) && ($this->encryption->decrypt($row->user_password) == $this->encryption->decrypt($changePasswordData['OldPassword']))){
				$logData['user_password'] =  $changePasswordData['NewPassword'];
				$this->db->where('user_name', $this->session->userdata('username'));
				$this->db->update($table, $logData);
				return 1;
			}
		}
		return 0;
	}
	
/*
===================================================================================================================
|																												  |
|											Delete													              |												  |
|																												  |
===================================================================================================================
*/	


	function deleteRPIconfData($event_id){
		$sql = "SELECT * FROM configure WHERE eventId=".$event_id;
		$query = $this->myDB->query($sql);
		$row = $query->row();
		$startDate = $row->startDate;
		$startTime = $row->startTime;

		$this->myDB->where('eventId',$event_id);
		$this->myDB->delete('configure');
		
		$this->myDB->where('startDate', $startDate);
		$this->myDB->where('startTime', $startTime);
		$this->myDB->delete('configuration');
		
		$this->myDB->where('startDate', $startDate);
		$this->myDB->where('startTime', $startTime);
		$this->myDB->delete('timeslot');
		
		$delsql = "DELETE FROM file WHERE fileName NOT IN (SELECT fileName FROM configuration)";
		$this->myDB->query($delsql);
		
	}
	function deleteEvent($event_id){
		
		$table=$this->get_table_event();
		$this->db->where('event_id',$event_id);
		$this->db->delete($table);
 	}
	
	function deleteLocation($event_id){
		
		$table=$this->get_table_location();
		$this->db->where('event_id',$event_id);
		$this->db->delete($table);		

 	}
	
	function deleteImage($event_id){
		
		$table=$this->get_table_image();				
		$this->db->where('event_id',$event_id);		
		$this->db->delete($table);			
			
 	}
	
	function deleteVideo($event_id){
		
		$table=$this->get_table_video();
		$this->db->where('event_id',$event_id);
		$this->db->delete($table);		
 	}
	
	function deleteAllImages(){
		
		$table=$this->get_table_image();
		$this->db->truncate($table);		
		
	}
	
/*
===================================================================================================================
|																												  |
|											update													              |												  |
|																												  |
===================================================================================================================
*/	
	
	function updateEvent($event_id,$addEventData){
		
		$table = $this->get_table_event();
		$this->db->where('event_id', $event_id);
		$result = $this->db->update($table,$addEventData);
		return $result;
	}
	
	function updateLocation($event_id,$addLocationData){
		
		$table = $this->get_table_location();
		$this->db->where('event_id', $event_id);
		$result = $this->db->update($table,$addLocationData);
		return $result;
	}
	
	function updateImage($event_id,$imageData){
		
		$table = $this->get_table_image();
		$this->deleteImage($event_id);
		$imageData['event_id'] = $event_id;
		$this->saveImage($imageData);
	}
	
	function updateVideo($event_id,$videoData){
		
		$table = $this->get_table_video();
		
		$data = $this->db->get($table);
		
		if($data->num_rows() > 0 ){
			
			$this->db->where('event_id', $event_id);
			$this->db->update($table,$videoData);
			
		}else{
			
			$videoData['event_id'] = $event_id;
			$this->db->insert($table, $videoData);
				
		}
	}
	
	function updateSettings($settingsData){
		
		$table = $this->get_table_setting();
		$result = $this->db->update($table, $settingsData);
		return $result;		
	}
	
	
	/*
===================================================================================================================
|																												  |
|											login													              |												  |
|																												  |
===================================================================================================================
*/	 
	
     function update_login($loginData){
		 		 
         $table = $this->get_table_login();
         $result = $this->db->update($table, $loginData);
         return $result; 
     }
	 
	 function insert_login($loginData){
		 
         $table = $this->get_table_login();
         $result = $this->db->insert($table, $loginData);
         return $result; 
     }
	 
	 function insert_setting($setingsData){
		
		$table = $this->get_table_setting();
		$result = $this->db->insert($table, $setingsData);
        return $result; 		 
	 }
	 
	 function get_login(){
		 
		 $table = $this->get_table_login();
		 $result = $this->db->get($table);
         return $result; 
	 }
/*
===================================================================================================================
|																												  |
|											install Database												              |												  |
|																												  |
===================================================================================================================
*/	
	 
     function install_event_calendar($databaseData){
		 
         $table = $this->get_table_install();
         $result = $this->db->insert($table, $databaseData);
         return $result; 
     }
	 
	 function event_calendar_login(){
		
		$this->load->dbforge();
		
		$fields = array(
				'user_name' => array(
					'type' => 'VARCHAR',
					'constraint' => '255'					
				),
				'user_email' => array(
					'type' => 'VARCHAR',
					'constraint' => '255'
				),
				'user_password' => array(
					'type' => 'VARCHAR',
					'constraint' => '255'
				),
				'nick_name' => array(
					'type' => 'VARCHAR',
					'constraint' => '50'
				)
		);
		
		$this->dbforge->add_field($fields, TRUE);
		$this->dbforge->add_key('user_email', TRUE);
		$this->dbforge->create_table('event_calendar_login', TRUE);	
		
		return 1;	
		
	}
	
	function event_calendar_event(){
	
		$this->load->dbforge();
		
		$fields = array(
				'event_id' => array(
					'type' => 'BIGINT',
					'constraint' => 20,
					'auto_increment' => TRUE			
				),
				'event_title' => array(
					'type' => 'VARCHAR',
					'constraint' => '255'
				),
				'start_date' => array(
					'type' => 'DATETIME',
				),
				'end_date' => array(
					'type' => 'DATETIME',
				),
				'event_address' => array(
					'type' => 'VARCHAR',
					'constraint' => '255'
				),
				'event_description' => array(
					'type' => 'LONGTEXT'					
				),
				'event_url' => array(
					'type' => 'VARCHAR',
					'constraint' => '255'
				),
				'event_view_url' => array(
					'type' => 'VARCHAR',
					'constraint' => '255'
				)
		);
		
		$this->dbforge->add_field($fields, TRUE);
		$this->dbforge->add_key('event_id', TRUE);
		$this->load->database();
		$this->dbforge->create_table('event_calendar_event', TRUE);	
		
		return 1;	
	
	}
	
	function event_calendar_location(){
	
	$this->load->dbforge();
	
	$fields = array(
			'location_id' => array(
				'type' => 'BIGINT',
				'constraint' => 20,
				'auto_increment' => TRUE			
			),
			'location' => array(
				'type' => 'VARCHAR',
				'constraint' => '255'
			),
			'radius' => array(
				'type' => 'INT',
				'constraint' => 11
			),
			'latitude' => array(
				'type' => 'DOUBLE'
			),
			'longitude' => array(
				'type' => 'DOUBLE'
			),
			'event_id' => array(
				'type' => 'BIGINT',
				'constraint' => 20
			)
	);
	
	$this->dbforge->add_field($fields, TRUE);
	$this->dbforge->add_key('location_id', TRUE);
	$this->dbforge->create_table('event_calendar_location', TRUE);	
	
	return 1;	
	
	}
	
	function event_calendar_image(){
	
	$this->load->dbforge();
	
	$fields = array(
			'image_id' => array(
				'type' => 'BIGINT',
				'constraint' => 20,
				'auto_increment' => TRUE
									
			),
			'image_name' => array(
				'type' => 'VARCHAR',
				'constraint' => '255'
			),
			'image_url' => array(
				'type' => 'VARCHAR',
				'constraint' => '255'
			),
			'image_thumb_url' => array(
				'type' => 'VARCHAR',
				'constraint' => '255'
			),
			'event_id' => array(
				'type' => 'BIGINT',
				'constraint' => 20
			)
	);
	
	$this->dbforge->add_field($fields, TRUE);
	$this->dbforge->add_key('image_id', TRUE);
	$this->dbforge->create_table('event_calendar_image', TRUE);	
	
	return 1;	
	
	}
	
	function event_calendar_video(){
	
	$this->load->dbforge();
	
	$fields = array(
			'video_id' => array(
				'type' => 'BIGINT',
				'constraint' => 20,
				'auto_increment' => TRUE
									
			),			
			'video_url' => array(
				'type' => 'LONGTEXT'	
			),
			'event_id' => array(
				'type' => 'BIGINT',
				'constraint' => 20
			)
	);
	
	$this->dbforge->add_field($fields, TRUE);
	$this->dbforge->add_key('video_id', TRUE);
	$this->dbforge->create_table('event_calendar_video', TRUE);	
	
	return 1;	
	
	}	
	
	function event_calendar_setting(){
	
	$this->load->dbforge();
	
	$fields = array(
			'setting_id' => array(
				'type' => 'INT',
				'auto_increment' => TRUE
									
			),			
			'first_day' => array(
				'type' => 'VARCHAR',
				'constraint' => '50'									
			),			
			'time_format' => array(
				'type' => 'VARCHAR',
				'constraint' => '50'				
			),
			'default_view' => array(
				'type' => 'VARCHAR',
				'constraint' => '50'				
			),
			'site_name' => array(
				'type' => 'VARCHAR',
				'constraint' => '255'				
			),
			'event_type' => array(
				'type' => 'VARCHAR',
				'constraint' => '50'				
			),
			'default_calendar_view' => array(
				'type' => 'VARCHAR',
				'constraint' => '50',				
			),
			'default_timezone' => array(
				'type' => 'VARCHAR',
				'constraint' => '100'				
			),
			'default_language' => array(
					'type' => 'VARCHAR',
					'constraint' => '100'
			),
			'mail_protocol' => array(
				'type' => 'VARCHAR',
				'constraint' => '100'
			),
			'mail_from' => array(
				'type' => 'VARCHAR',
				'constraint' => '100'				
			),
			'from_name' => array(
				'type' => 'VARCHAR',
				'constraint' => '100'				
			),
			'smtp_host' => array(
				'type' => 'VARCHAR',
				'constraint' => '100',
				'null' => TRUE
			),
			'smtp_username' => array(
				'type' => 'VARCHAR',
				'constraint' => '100',
				'null' => TRUE
			),
			'smtp_password' => array(
				'type' => 'VARCHAR',
				'constraint' => '100',
				'null' => TRUE
			),
			'smtp_port' => array(
				'type' => 'INT',
				'constraint' => 11,
				'null' => TRUE
			),
	);
	
	$this->dbforge->add_field($fields, TRUE);
	$this->dbforge->add_key('setting_id', TRUE);
	$this->dbforge->create_table('event_calendar_setting', TRUE);	
	
	return 1;	
	
	}
	 
 }
 
 /*
 *End of Event_calendar_admin_model.php
 *Source: ../application/modules/admin/models/Event_calendar_admin_model.php
 */

