<?php if($this->session->userdata('default_lang')): ?>
	<?php $this->lang->load('user', $this->session->userdata('default_lang')); ?>
<?php endif; ?>

<!DOCTYPE html>

<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title><?php if(isset($title)) echo $title; ?></title>        
        <link href="<?php echo base_url('assets/front/css/bootstrap.min.css'); ?>" rel="stylesheet"> 
        <link href="<?php echo base_url('assets/front/css/stylesheet.css'); ?>" rel="stylesheet">
  </head>
  <body>

	<div class="container">
		<?php if( $events->num_rows() > 0): ?>	
		<div class="row">
			<div class="col-md-12">			
				<?php $event = $events->row(); ?>
				<?php $event_id = $event->event_id; ?>
				<?php $event_title = $event->event_title; ?>
				<?php $start_date = date_format(date_create($event->start_date), 'd-M-Y h:i a'); ?>
				<?php $end_date = date_format(date_create($event->end_date), 'd-M-Y h:i a'); ?>
				<?php $event_address = $event->event_address; ?>
				<?php $event_description = $event->event_description; ?>

				<?php if( $locations->num_rows() > 0): ?>
					<?php $loc = $locations->row(); ?>
					<?php $location_id = $loc->location_id; ?>
					<?php $location = $loc->location; ?>
					<?php $radius = $loc->radius; ?>
					<?php $latitude = $loc->latitude; ?>
					<?php $longitude = $loc->longitude; ?>        
				<?php endif; ?>
				
				<?php if( $videos->num_rows() > 0): ?>	
					<?php $video_url = $videos->row()->video_url; ?>        
				<?php endif; ?>
				
				<div class="page-header">
					<h1>
						<?php if(isset($event_title)) echo $event_title;?> <small><?= isset($start_date) ? $start_date : "";?></small>
						<a class="btn btn-default pull-right" id="btn-back" href="javascript:void(0)"><?= ($this->lang->line('view_event_backtolist_btn')) ? $this->lang->line('view_event_backtolist_btn') : "Back To List"; ?></a>
					</h1>
				</div>
				
				<div class="row">
					<div class="col-md-6 event-dates">
						<span class="glyphicon glyphicon-calendar" aria-hidden="true"></span>
						<ul class="list-unstyled">
							<li><strong><?= ($this->lang->line('view_event_startdate')) ? $this->lang->line('view_event_startdate') : "Start Date"; ?>:</strong> <?= isset($start_date) ? $start_date : "";?></li>
							<li><strong><?= ($this->lang->line('view_event_enddate')) ? $this->lang->line('view_event_enddate') : "End Date"; ?>:</strong> <?= isset($end_date) ? $end_date : "";?></li>
						</ul>
					</div>
					<div class="col-md-6 event-address">
						<address>
							<span class="glyphicon glyphicon-map-marker" aria-hidden="true"></span>
							<p class="address">
							 <strong><?= ($this->lang->line('view_event_address')) ? $this->lang->line('view_event_address') : "Address"; ?></strong><br />
							 <?php if(isset($event_address)) echo $event_address; ?>
							</p>
						</address>
					</div>                    
				</div>
				<?php if( $images->num_rows() > 0):?>
					<div id="carousel" class="carousel slide" data-ride="carousel">
						<ol class="carousel-indicators">						
							<?php $isFirst = true; ?>
							<?php for($i=0; $i<count($images->result()); $i++):?>
								<li data-target="#carousel" data-slide-to="<?php echo $i;?>" class="<?php if($isFirst == true) { ?>active<?php } ?>"></li>
								<?php $isFirst = false; ?>
							<?php endfor; ?>                       
						</ol>                   
						
					   <div class="carousel-inner" role="listbox">					
							<?php $isFirst = true; ?>
							<?php  foreach( $images->result() as $image): ?>
								<div class="item <?php if($isFirst == true) { ?>active<?php } ?>">
									<img data-src="<?php echo $image->image_name; ?>" src="<?php echo $image->image_url; ?>" data-holder-rendered="true" width="900px" height="386px">
								</div>
							<?php $isFirst = false; ?>
							<?php endforeach; ?>                   
						</div>  
										  
						<a class="left carousel-control" href="#carousel" role="button" data-slide="prev">
							<span class="glyphicon glyphicon-chevron-left" aria-hidden="true"></span>
							<span class="sr-only">Previous</span>
						</a>
						<a class="right carousel-control" href="#carousel" role="button" data-slide="next">
							<span class="glyphicon glyphicon-chevron-right" aria-hidden="true"></span>
							<span class="sr-only">Next</span>                  
						</a>                   
				   </div>
				   <hr />
				 <?php endif; ?>          
				
				<?php if(isset($video_url)): ?>
					<div class="embed-responsive embed-responsive-16by9">
						<?php  echo $video_url; ?>
					</div> 
					<hr />         
				 <?php endif; ?>
				 
				<div class="row">
					<div class="col-md-6">
						<description>
							<strong><?= ($this->lang->line('view_event_description')) ? $this->lang->line('view_event_description') : "Description"; ?></strong><br />
							<p><?php if(isset($event_description) && !empty($event_description)) echo $event_description; 
										else echo "None";?></p>
						</description>
					</div>
					<div class="col-md-6">
						<input type="hidden" id="evnt2-lat" value="<?php if(isset($latitude)) echo $latitude; ?>"/>
						<input type="hidden" id="evnt2-lon" value="<?php if(isset($longitude)) echo $longitude;?>" />
						<input type="hidden" id="evnt2-radius" value="<?php if(isset($radius)) echo $radius; ?>" />
						<div id="evnt2"></div>                      
					</div>
				</div>
			</div>
		</div>
		<?php else: ?>
			<div class="not-found" style="text-align:center"><h5><strong>Invalid ID:  </strong> Event Not Found</h5></div>
		<?php endif; ?>
		<input type="hidden" id="projectname" value="<?php echo base_url(); ?>" />
    </div>
	  
		<script type="text/javascript" src="<?php echo base_url('assets/front/js/jquery.min.js'); ?>"></script>  
        <script type="text/javascript" src="<?php echo base_url('assets/front/js/boostrap.min.js'); ?>"></script>        
        <script type="text/javascript" src="<?php echo  base_url('assets/front/js/locationpicker.jquery.js'); ?>"></script>
        <script type="text/javascript" src="http://maps.google.com/maps/api/js?sensor=false&libraries=places"></script>
        <script type="text/javascript" src="<?php echo base_url('assets/front/js/map-action.js'); ?>"></script>       
        <script type="text/javascript">
        	$(document).ready(function(){	
				$('#btn-back').click(function(){
					if( history.length > 1){									
						history.go(-1)	
					}else{
						window.location.href = $('#projectname').val();	
					}
				});
			});
        </script>    
	</body>
</html>