$(document).ready(function(){

	var urlpath = $('#projectname').val();
	var type = $('#type').val();
	var defaultCalView = $('#default-calendar-view').val();
	var first_day = $('#FirstDay').val();
	var time_format = ($('#TimeFormat').val() == '1') ? true : false;
	var deafult_language = $('#DefaultLang').val();
	var options = {
		events_source: urlpath + 'EventCalendarAjaxHandler/getAllEvents/' + type,
		view: defaultCalView,
		tmpl_path: urlpath + 'assets/calendar/',
		tmpl_cache: false,
		day: current_date(),
		display_week_numbers: true,
		weekbox: true,
		first_day: first_day,
		format12: time_format,
		language: deafult_language,
		onAfterViewLoad: function(view) {
			$('.page-header h3').text(this.getTitle());
			$('.btn-group button').removeClass('active');
			$('button[data-calendar-view="' + view + '"]').addClass('active');
		},
		classes: {
			months: {	general: 'label'
			}
		}
	
	};
	
	function current_date(){
		
		var today = new Date();
		var dd = today.getDate();
		if(dd < 10){ dd = "0" + dd; }
		var mm = today.getMonth() + 1;
		if(mm < 10){ mm = "0" + mm; }
		var yyyy = today.getFullYear();
		
		return  yyyy + "-" + mm + "-" + dd;
		
			
	}
	
	
	var calendar = $('#calendar').calendar(options);
	
	$('.btn-group button[data-calendar-nav]').each(function() {
		var $this = $(this);
		$this.click(function() {
			calendar.navigate($this.data('calendar-nav'));
		});
	});
	
	$('.btn-group button[data-calendar-view]').each(function() {
		var $this = $(this);
		$this.click(function() {
			calendar.view($this.data('calendar-view'));
		});
	});

	
});