var margin;
var parseDate;
var x, y, xAxis, yAxis;
var color, line, svg;
function createSVG(myFile, board, dataType){
	margin = {top: 60, right: 760, bottom: 60, left: 760},
		width = 960 ,
		height = 600;

	parseDate = d3.time.format("%Y-%m-%dT%H:%M:%S").parse;
	//%H:%M:%S or %H:%M:%L

	x = d3.time.scale()
		.range([0, width]);

	y = d3.scale.linear()
		.range([height, 0]);

	color = d3.scale.category10();

	xAxis = d3.svg.axis()
		.scale(x)
		.orient("bottom");

	yAxis = d3.svg.axis()
		.scale(y)
		.orient("left");

	line = d3.svg.line()
		.interpolate("basis")
		.x(function(d) { return x(d.date); })
		.y(function(d) { return y(d.val); });

	svg = d3.select("body").append("svg")
		.attr("width", width + margin.left + margin.right)
		.attr("height", height + margin.top + margin.bottom)
	  .append("g")
		.attr("transform", "translate(" + margin.left + "," + margin.top + ")");

	d3.tsv(myFile, function(error, data) {
	  color.domain(d3.keys(data[0]).filter(function(key) { return key !== "date"; }));
	  
	data.forEach(function(d) {
		d.date = parseDate(d.date);
	  });

	  var axe = color.domain().map(function(name) {
		return {
		  name: name,
		  values: data.map(function(d) {
			return {date: d.date, val: +d[name]};
		  })
		};
	  });

	  x.domain(d3.extent(data, function(d) { return d.date; }));

	  y.domain([
		//d3.min(axe, function(c) { return d3.min(c.values, function(v) { return v.val; }); }),
		0,d3.max(axe, function(c) { return d3.max(c.values, function(v) { return v.val; }); })
	  ]);

	  svg.append("g")
		  .attr("class", "x axis")
		  .attr("transform", "translate(0," + height + ")")
		  .call(xAxis)
		  .append("text")
		  .attr("dy", ".45em")
		  .attr("dx", "65.47em")
		  .style("text-anchor", "end")
		  .text("Date/Time");

	  svg.append("g")
		  .attr("class", "y axis")
		  .call(yAxis)
		.append("text")
		  //.attr("transform", "rotate(-90)")
		  .attr("y", 0 - (margin.top / 2))
		  .attr("dx", ".91em")
		  .attr("dy", ".71em")
		  .style("text-anchor", "end")
		  .text(dataType);
		  
	  svg.append("text")
		.text(board)
		.attr("x", (width / 2))             
        .attr("y", 0 - (margin.top / 2))
        .attr("text-anchor", "middle")  
        .style("font-size", "14px");
        

	  var axes = svg.selectAll(".axes")
		  .data(axe)
		.enter().append("g")
		  .attr("class", "axes");

	  axes.append("path")
		  .attr("class", "line")
		  .attr("d", function(d) { return line(d.values); })
		  .style("stroke", function(d) { return color(d.name); });

	  axes.append("text")
		  .datum(function(d) { return {name: d.name, value: d.values[d.values.length - 1]}; })
		  .attr("transform", function(d) { return "translate(" + x(d.value.date) + "," + y(d.value.val) + ")"; })
		  .attr("x", 3)
		  .attr("dy", ".35em")
		  .text(function(d) { return d.name; });
	});

		
	
}

function updateData(myFile) {
	x = d3.time.scale()
		.range([0, width]);

	y = d3.scale.linear()
		.range([height, 0]);
	line = d3.svg.line()
		.interpolate("basis")
		.x(function(d) { return x(d.date); })
		.y(function(d) { return y(d.val); });
	// Get the data again
	
	d3.tsv(myFile, function(error, data) {
	  color.domain(d3.keys(data[0]).filter(function(key) { return key !== "date"; }));
	  
	data.forEach(function(d) {
		d.date = parseDate(d.date);
	  });

	  var axe = color.domain().map(function(name) {
		return {
		  name: name,
		  values: data.map(function(d) {
			return {date: d.date, val: +d[name]};
		  })
		};
	  });

	  x.domain(d3.extent(data, function(d) { return d.date; }));

	  y.domain([
		//d3.min(axe, function(c) { return d3.min(c.values, function(v) { return v.val; }); }),
		0,d3.max(axe, function(c) { return d3.max(c.values, function(v) { return v.val; }); })
	  ]);

	svg = d3.select("body").transition();
	  var axes = svg.selectAll(".axes")
		  .data(axe)
		.enter().append("g")
		  .attr("class", "axes");

	  axes.append("path")
		  .attr("class", "line")
		  .attr("d", function(d) { return line(d.values); })
		  .style("stroke", function(d) { return color(d.name); });

	  //svg = d3.select("body").transition();
		
		// Make the changes
			svg.select(".line")   // change the line
				//.duration(1000)
				.attr("d", line(data));
			svg.select(".x.axis") // change the x axis
				//.duration(1000)
				.call(xAxis);
			svg.select(".y.axis") // change the y axis
				//.duration(1000)
				.call(yAxis);
			
	});
}

	
	
